it.reply.healty.innovapuglia.mstaccuino.service.data

## Class ProtesiDataService

- java.lang.Object
- - it.reply.healty.innovapuglia.mstaccuino.service.data.ProtesiDataService

- All Implemented Interfaces:
    IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>

      @Component
      public class ProtesiDataService
      extends Object
      implements IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ProtesiDataService()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Protesi` | `addNtt(NotaTaccuino nota, ProtesiAusilioRequestDTO protesiRequest)` Aggiunge al database una nuova istanza di tipo Protesi o Ausilio
    `void` | `deprecaNtt(Protesi protesi)` Cancella logicamente l'istanza di tipo Protesi inserita in input
    `List<Protesi>` | `findAllNttById(String idNota)` Recupera l'elenco di Protesi associati ad un id nota
    `Protesi` | `getNttById(String idProtesi)` Restituisce la protesi in stato attivo in base all'ID in input
    `Protesi` | `updateNtt(Protesi protesi, ProtesiAusilioRequestDTO newProtesiDto)` Crea e salva un'istanza di tipo Protesi aggiornata con i dati in input, e depreca la vecchia istanza

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ProtesiDataService

          public ProtesiDataService()

  - ### Method Detail

    - #### addNtt

          public Protesi addNtt(NotaTaccuino nota,
                                ProtesiAusilioRequestDTO protesiRequest)
                         throws FaultException

      Aggiunge al database una nuova istanza di tipo Protesi o Ausilio
      Specified by:
        `addNtt` in interface `IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>`
      Parameters:
        `nota` - Istanza della nota a cui e' associato l'oggetto
        `protesiRequest` - Oggetto contenente i dati di input della protesi o ausilio
      Returns:
        l'istanza creata
      Throws:
        `FaultException` - quando ci sono problemi nel salvataggio dei dati nel database

    - #### deprecaNtt

          public void deprecaNtt(Protesi protesi)
                          throws FaultException

      Cancella logicamente l'istanza di tipo Protesi inserita in input
      Specified by:
        `deprecaNtt` in interface `IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>`
      Parameters:
        `protesi` - istanza dell'oggetto da deprecare
      Throws:
        `FaultException` - quando ci sono problemi nel salvataggio dei dati nel database

    - #### updateNtt

          public Protesi updateNtt(Protesi protesi,
                                   ProtesiAusilioRequestDTO newProtesiDto)
                            throws FaultException

      Crea e salva un'istanza di tipo Protesi aggiornata con i dati in input, e depreca la vecchia istanza
      Specified by:
        `updateNtt` in interface `IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>`
      Parameters:
        `protesi` - Vecchia istanza dell'oggetto da modificare
        `newProtesiDto` - Nuovo oggetto in input, contenente i dati aggiornati
      Returns:
        l'istanza aggiornata
      Throws:
        `FaultException` - quando ci sono problemi nel salvataggio dei dati nel database

    - #### getNttById

          public Protesi getNttById(String idProtesi)
                             throws FaultException,
                                    ProtesiNonTrovatoException

      Restituisce la protesi in stato attivo in base all'ID in input
      Specified by:
        `getNttById` in interface `IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>`
      Parameters:
        `idProtesi` - l'ID della protesi da cercare
      Returns:
        La protesi attiva trovata
      Throws:
        `FaultException` - Quando c'è qualche problema durante l'interrogazione del database
        `ProtesiNonTrovatoException` - Quando non viene trovata nessuna protesi attiva con quell'ID

    - #### findAllNttById

          public List<Protesi> findAllNttById(String idNota)
                                       throws FaultException

      Recupera l'elenco di Protesi associati ad un id nota
      Specified by:
        `findAllNttById` in interface `IDataService<NotaTaccuino,ProtesiAusilioRequestDTO,Protesi,ProtesiNonTrovatoException>`
      Parameters:
        `idNota` - l'ID della nota
      Returns:
        l'elenco di Protesi, o una lista vuota quando non ce ne sono
      Throws:
        `FaultException` - quando ci sono problemi nel recupero dati dal database

Copyright © 2024. All rights reserved.